/******************************************************************************/
/*									      */
/* Program to test malloc system call.					      */
/*									      */
/******************************************************************************/
#include  <stdio.h>
#include  <errno.h>
#include  <string.h>
#include  <stdlib.h>
#include  <sys/resource.h>

main(int argc, char **argv)
{
	char *endptr ;
	int argerr = FALSE ;
	char msgbuff[80] ;
	char cmdname[16] ;
	int flagchar ;

	unsigned long testsize ;
	char *testptr ;
	struct rlimit datalimits ;

/******************************************************************************/
/*									      */
/*	Get command name from command line.				      */
/*									      */
/******************************************************************************/
	endptr=strrchr(argv[0],'/') ;
	if (endptr == NULL)
	  {
	  endptr=argv[0] ;
	  }
	else ++endptr ;
	if (strlen(endptr) > sizeof(cmdname)-1)
	  {
	  fprintf(stderr,"Command name %s ends in a file name that is more than %i chars long!\n",argv[0],sizeof(cmdname)-1) ;
	  exit(1) ;
	  }
	else strcpy(cmdname,endptr) ;

/******************************************************************************/
/*									      */
/*	Get command parameters from command line.			      */
/*									      */
/******************************************************************************/
	if (argc-optind == 1)	/* If there is one parameter... */
	  {
	  /********************************************************************/
	  /*								      */
	  /* Get malloc size from command line.				      */
	  /*								      */
	  /********************************************************************/
	  testsize=strtoul(argv[optind],&endptr,10) ;
	  if (endptr-argv[optind] != strlen(argv[optind]))
	    {
	    fprintf(stderr,"%s: First parameter (%s) is not an unsigned integer!\n",cmdname,argv[optind]) ;
	    fprintf(stderr,"%s: Only %u characters converted!\n",cmdname,endptr-argv[optind]) ;
	    argerr=TRUE ;
	    }
	  }
	else
	  argerr=TRUE ;

/******************************************************************************/
/*									      */
/*	If any parameter errors were detected, write error message and quit.  */
/*									      */
/******************************************************************************/
	if (argerr)
	  {
	  fprintf(stderr,"Usage: %s testsize\n",cmdname) ;
	  exit(2) ;
	  }

/******************************************************************************/
/*									      */
/*      Invoke malloc and issue message.				      */
/*									      */
/******************************************************************************/
	getrlimit(RLIMIT_DATA,&datalimits) ;
	printf("Current data limit is %lu.\n",datalimits.rlim_cur) ;
	printf("Maximum possible data limit is %lu.\n",datalimits.rlim_max) ;
	testptr=malloc(testsize) ;
	if (errno == 0)
	  {
	  printf("Allocated %lu bytes.\n",testsize) ;
	  printf("Memory is now allocated.  Press enter to free memory: ") ;
	  flagchar=getchar() ;
	  free(testptr) ;
	  if (errno != 0)
	    {
	    sprintf(msgbuff,"%s: Call to free(%X) failed",cmdname,testptr) ;
	    perror(msgbuff) ;
	    }
	  }
	else
	  {
	  sprintf(msgbuff,"%s: Call to malloc(%lu) failed",cmdname,testsize) ;
	  perror(msgbuff) ;
	  }

/******************************************************************************/
/*									      */
/*	Return to caller.						      */
/*									      */
/******************************************************************************/
	exit(errno);

}
